//md2view.cpp
#include <windows.h>
#include <time.h>
#include "./dx_base/graphics.h"
#include "md2view.h"
#include "./md2/md2.h"


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	CMd2View * pApp = new CMd2View;

	pApp->m_mainParam.hInstance = hInstance;
	pApp->m_mainParam.lpCmdLine = lpCmdLine;
	pApp->m_mainParam.nCmdShow = nCmdShow;

	pApp->Register(pApp, "Md2 Viewer", 800, 600); 
	pApp->Run();
	pApp->Release();
	return 0;
}
//---------------------------------------------------------------------------------
CMd2View::CMd2View()
{
	m_pMd2 = NULL;
}
//---------------------------------------------------------------------------------
CMd2View::~CMd2View()
{
	SAFE_DELETE(m_pMd2);
}
//---------------------------------------------------------------------------------
bool CMd2View::PostGraphics()
{
	m_pMd2 = new CMd2;

	IDirect3DDevice9 * pDevice = m_pGraphics->GetDevice();
	m_pMd2->Load("TRIS.MD2", "solo.bmp", pDevice);
	return true;
}
//---------------------------------------------------------------------------------
void CMd2View::Cleanup()
{
	m_pMd2->Release();

	CApplication::Cleanup();
}
//---------------------------------------------------------------------------------
void CMd2View::Update()
{
	float time = (float)GetTickCount();
	m_pMd2->Update(time);
}
//---------------------------------------------------------------------------------
void CMd2View::Render()
{
	D3DXMATRIX   matScale, matRot, matWorld;
	D3DXMatrixScaling( &matScale, m_cameraRef.fScale, m_cameraRef.fScale, m_cameraRef.fScale);
	D3DXMatrixRotationYawPitchRoll( &matRot, D3DXToRadian(m_cameraRef.fRotateX), D3DXToRadian(m_cameraRef.fRotateY), 0.0f );
	
	matWorld = matScale * matRot;
	
	IDirect3DDevice9 * pDevice = m_pGraphics->GetDevice();
	pDevice->SetTransform(D3DTS_WORLD, &matWorld);
	m_pMd2->Render(pDevice);
}
//---------------------------------------------------------------------------------
bool CMd2View::ProcessKey(HWND hWnd, WPARAM wKey)
{

	if(wKey == VK_SPACE)
	{
		m_pMd2->SetAnimationKey();
		return true;		
	}

	return CApplication::ProcessKey(hWnd, wKey);
}
